// Parašyti programą iterpimo rušiavimo algoritmui, kuri dirba daug kartu ir 
// rušiuoja ivairiu dydžiu failus, matuodama darbo laiką, skaičiuodama lyginimo 
// operaciju kieki, ir sudaro tokiu darbo laiku ir kiekiu pasiskirstymą.

#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;

const char REZ_BYLA[] = "dsa1.rez";
const int KIEKIS = 10;

void rikiuoti(int *mas, long int n, long int &keit, long int &lyg)
{
	int i, j, v;
	
	keit = 0;
	lyg = 0;
	lyg++;
	for (i=1; i<n; ++i)
	{
		v = mas[i];
		j = i;
		lyg++;
		while ((mas[j-1] > v)&&(j > 0))
		{
			mas[j] = mas[j-1];
			j = j-1;
			lyg += 2;
			keit++;
		}
		keit++;
		mas[j] = v;
		lyg++;
	}
}


int *kurti_masyva(int dyd)
{
	int *mas = new int[dyd];
	int i;
	for (i=0; i<dyd; i++)
	{
		mas[i] = rand();
	}
	return mas;
}

/*bool skaityti_byla(const char *vard, char **mas, long int &dyd)
{
	ifstream byla;
	
	byla.open(vard, ifstream::binary);
	if (!byla.is_open()) return false;
	
	// gauti bylos dydį
	byla.seekg (0, ios::end);
	dyd = byla.tellg();
	byla.seekg (0, ios::beg);
	
	// paskiriama vieta masyvui
	*mas = new char[dyd];
	if (!*mas) return false;
	
	// skaitoma byla
	byla.read(*mas, dyd);
	
	byla.close();
	return true;
}
*/

bool rasyti_rez(const char *vard, long int n, long int *dyd, 
	long int *keit, long int *lyg)
{
	ofstream byla;
	long int i;
	
	const char *ANTRASTE =
		"dydis\tkeitmai\tlyginimai\n---------------------------------------\n";
	
	byla.open(vard, ofstream::binary);
	if (!byla.is_open()) return false;
	
	cout << ANTRASTE;
	byla << ANTRASTE;
	for (i=0; i<n; ++i)
	{
		cout << dyd[i] << '\t' << keit[i] << '\t' << lyg[i] << endl;
		byla << dyd[i] << '\t' << keit[i] << '\t' << lyg[i] << endl;
	}
	
	byla.close();
	return true;
}


int main()
{
	long int *keit, *lyg, *dyd;
	long int i;
	int *mas;
	
	srand(time(NULL));
	
	keit = new long int[KIEKIS];
	lyg = new long int[KIEKIS];
	dyd = new long int[KIEKIS];
	
	for (i=0; i<KIEKIS; ++i)
	{
		dyd[i] = rand()%10000;
		mas = kurti_masyva(dyd[i]);
		rikiuoti(mas, dyd[i], keit[i], lyg[i]);
		delete[] mas;
	}
	
	rasyti_rez(REZ_BYLA, KIEKIS, dyd, keit, lyg);
	
	delete[] keit;
	delete[] lyg;
	delete[] dyd;
	return 0;
}

