/* pagrindinio lango klasė MainWnd
 */

#ifndef MAINWND_H
#define MAINWND_H

#include <qmainwindow.h>
#include <qlabel.h>

class GridView;

class MainWnd: public QMainWindow
{
	Q_OBJECT
	private:
		GridView *gridview;
		QLabel *point_count;
		QLabel *list_count;
		QLabel *cmp_count;
		QLabel *found_count;
	protected slots:
		void toggledAddPoints(bool on);
		void toggledSelectInterval(bool on);
		void clear();
		void search();
		void updatePointCount();
		void updateListCount();
		void updateCmpCount();
		void updateFoundCount();
		void gridWidthChanged(int value);
		void gridHeightChanged(int value);
		void putRandomPoints();
	public:
		MainWnd(QWidget *parent=0, const char *name=0);
		~MainWnd();
};

#endif
